<?php
namespace app\admin\model;

class ExpressData extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'order_out_id'       =>'int',//发货单ID
        'out_child_id'       =>'int',//订单号
        'post_code'       =>'varchar',//快递编号
        'post_name'       =>'varchar',//快递公司
        'post_express'       =>'varchar',//快递公司缩写
        'post_logo'       =>'varchar',//快递logo
        'post_data'       =>'text',//快递信息主体
        'contactor'       =>'varchar',//联系人
        'mobile'       =>'varchar',//联系电话
        'status'       =>'tinyint',//'Fail': 0,'WAIT_ACCEPT': 1,  # 待揽收 'ACCEPT': 2,  # 已揽收'TRANSPORT': 3,  # 运输中'DELIVERING': 4,  # 派件中'AGENT_SIGN': 5,  # 已代签收'SIGN': 6,  # 已签收'FAILED': 7  # 包裹异常
        'remark'       =>'varchar',//备注
        'crontab_num'       =>'int',//执行失败次数超过三次不执行
        'addtime'       =>'datetime',//新建时间
        'updatetime'       =>'datetime',//更新时间
    ];
    protected static $status=[
        0=>'未获取到数据',
        1=>'待揽收',
        2=>'已揽收',
        3=>'运输中',
        4=>'派件中',
        5=>'已代签收',
        6=>'已签收',
        7=>'包裹异常',
    ];

//    WAIT_ACCEPT: 待揽收	RECEIVE: 接单中
//                        WAIT_ACCEPT: 待揽收
//    ACCEPT: 已揽收	    ACCEPT: 已揽收
//    TRANSPORT: 运输中	TRANSPORT: 运输中
//                        ON_THE_WAY: 在途中
//                        SEND_ON: 转单或修改地址转寄
//                        ARRIVE_CITY: 到达目的城市
//    DELIVERING: 派件中	DELIVERING: 派件中
//                        STA_INBOUND: 已放入快递柜或驿站
//    AGENT_SIGN: 已代签收	AGENT_SIGN: 已代签收
//    SIGN:已签收	        SIGN: 已签收
//                        STA_SIGN: 从快递柜或者驿站取出
//    FAILED:包裹异常 	    FAILED: 包裹异常
//                        TIMEOUT_UNSIGEN: 超时未签收
//                        TIMEOUT_NO_UPDATE: 超时未更新
//                        REFUSE_SIGN: 拒收
//                        DELIVER_ABNORMAL: 派件异常
//                        STA_TIMEOUT_UNSIGEN: 快递柜或者驿站超时未取
//                        CONTACT_FAIL: 无法联系
//                        OVER_AREA: 超区
//                        RETENTION: 滞留件
//                        ISSUE: 问题件
//                        RETURN: 退回件
//                        SEND_NO_MESSAGE: 发货无信息
//                        DAMAGE: 破损

    protected  $ExpressStatus=[
        'WAIT_ACCEPT'=>'待揽收',
        'ACCEPT'=>'已揽收',
        'TRANSPORT'=>'运输中',
        'DELIVERING'=>'派件中',
        'AGENT_SIGN'=>'已代签收',
        'SIGN'=>'已签收',
        'FAILED'=>'包裹异常',
    ];
    protected $ExpressChildStatus=[
        "RECEIVE"=>'接单中',
        "WAIT_ACCEPT"=> "待揽收",
        "ACCEPT"=> "已揽收",
        "TRANSPORT"=> "运输中",
        "ON_THE_WAY"=> "在途中",
        "SEND_ON"=> "转单或修改地址转寄",
        "ARRIVE_CITY"=> "到达目的城市",
        "DELIVERING"=> "派件中",
        "STA_INBOUND"=> "已放入快递柜或驿站",
        "AGENT_SIGN"=> "已代签收",
        "SIGN"=> "已签收",
        "STA_SIGN"=> "从快递柜或者驿站取出",
        "FAILED"=> "包裹异常",
        "TIMEOUT_UNSIGEN"=> "超时未签收",
        "TIMEOUT_NO_UPDATE"=> "超时未更新",
        "REFUSE_SIGN"=> "拒收",
        "DELIVER_ABNORMAL"=> "派件异常",
        "STA_TIMEOUT_UNSIGEN"=> "快递柜或者驿站超时未取",
        "CONTACT_FAIL"=> "无法联系",
        "OVER_AREA"=> "超区",
        "RETENTION"=> "滞留件",
        "ISSUE"=> "问题件",
        "RETURN"=> "退回件",
        "SEND_NO_MESSAGE"=> "发货无信息",
        "DAMAGE"=> "破损"
        ];
    protected  $json=['post_data'];
    protected $jsonAssoc = true;
    protected $append=['status_cn'];
    public  function getStatusCnAttr($value,$data){
        return self::$status[$data['status']]??$value;
    }
    public function OrderOut(){
      return $this->belongsTo('OrderOut','order_out_id','id')->bind(["outCode","orderCode","dfStatus"=>"status","send_status"]);
    }
    public function OrderChild(){
        return $this->belongsTo('OrderOutChild','out_child_id','id')->bind(['outChildCode','ChStatus'=>'status',"sender"]);
    }
     public  function getPostDataAttr($value){
       if(!empty($value)){
           foreach ($value as $k=>$v){
               $value[$k]['time']=date("Y-m-d H:i:s",$v['time']/1000);
               $value[$k]['subLogisticsStatus_cn']=$this->ExpressChildStatus[$v['subLogisticsStatus']]??$v['subLogisticsStatus'];
               $value[$k]['logisticsStatus_cn']=$this->ExpressStatus[$v['logisticsStatus']]??$v['logisticsStatus'];
           }
           return $value;
       }else{
           return [];
       }
    }
}