<?php
declare (strict_types = 1);

namespace app\cxinv\controller;

use app\common\Ocr;
use app\cxinv\model\GodTemp;
use app\user\model\TaxCompany;
use think\App;
use think\Request;

class Index extends Base
{

    public function __construct(App $app)
    {
        parent::__construct($app);
    }
    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {
        $param=request()->param();
        $ocr= Ocr::getInstance();
        $code=$param['code'];
        $number=$param['number'];
        $issueDate=$param['issueDate'];
        $checkCode=$param['checkCode'];
        $subtotalAmount=$param['subtotalAmount'];

        $data=$ocr->InvoiceVerification($code,$number,$issueDate,$checkCode,$subtotalAmount);

      return  json($data);

    }
    //商品库模糊查询
    public function List()
    {
        $param = $this->request->param(['goodName'=>"","code"=>"","companyNo"=>"","page"=>1,"size"=>20],"post",'trim');
       $where=[["status","<>",0]];
       if($param['goodName']!='') $where[]=['goodName','like','%'.$param['goodName'].'%'];
       if($param['code']!='') $where[]=['code','like','%'.$param['code'].'%'];
       if($param['companyNo']!=''){
           $inTax = TaxCompany::with(['tax'])->where(['companyNo'=>$param['companyNo'],'income'=>1])->select();
           $magerCode= array_column($inTax->toArray(),'merge_code');
           $where[]=['cat_code','in',$magerCode];
       }

       $list = GodTemp::with(['tax_info'])->where($where)->order('id desc')->paginate(['page'=>$param['page'],'list_rows'=>$param['size']]);
       return success("获取成功",['list'=>$list->items(),'count'=>$list->total()]);
    }

    /**
     * 保存新建的资源
     *
     * @param  \think\Request  $request
     * @return \think\Response
     */
    public function save(Request $request)
    {
        //
    }

    /**
     * 显示指定的资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function read($id)
    {
        //
    }

    /**
     * 显示编辑资源表单页.
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * 保存更新的资源
     *
     * @param  \think\Request  $request
     * @param  int  $id
     * @return \think\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * 删除指定资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function delete($id)
    {
        //
    }
}
