<?php


namespace app\cxinv\controller;


use app\cxinv\model\OrderTag;
use app\cxinv\model\QrdInfo;use think\App;
class Sale extends Base{
    public function __construct(App $app) {
        parent::__construct($app);
        $this->model=new QrdInfo();
    }

    public function status(){
      $param= $this->request->param(["id"=>"","status"=>""],"post","trim");
      $valid= $this->validate($param,[
          'id|订单编号'=>'require|number',
          'status|订单状态'=>'require|number|in:0,1,2,3'
      ]);
      if($valid!==true) return error($valid);
      $model= $this->model->findOrEmpty($param['id']);
      if($model->isEmpty())return error("订单不存在");
      if($model->status==$param['status']) return error("订单状态已更新");
      $model->status=$param['status'];
      $save = $model->save();
      if($save===false)return error("更新失败");
      return success("更新成功");
    }

    public function list(){
    }

    //给订单批量添加发票标签
    public function addBatchTag(){
        $params = $this->request->param(["idArr"=>[],"tag_id"=>''],"post","trim");
        $valid = $this->validate($params,[
            'idArr|订单编号'=>'require|array',
            'tag_id|标签id'=>'require|number|gt:0'
        ]);
        if($valid!==true) return error($valid);
        $qrdArr = $this->model->whereIn("id",$params['idArr'])->select();
        if($qrdArr->isEmpty()) return error("订单不存在");
        $taginfo = OrderTag::where("id",$params['tag_id'])->findOrEmpty();
        if($taginfo->isEmpty()) return error("标签不存在");
        if(!in_array($taginfo['type'],[3,4])) return error("该标签类型不是订单标签");
        $this->model->startTrans();
        try{
            foreach ($qrdArr as $k=>$v){
                $v->creater = $this->uname;
                $v->createrid = $this->uid;
                $this->model->AddTag($v,$params['tag_id']);
            }
            $this->model->commit();
        }catch (\Exception $e){
            $this->model->rollback();
            return error($e->getMessage());
        }
        return success("批量添加成功");
    }
}